> ## Documentation Index
> Fetch the complete documentation index at: https://docs.permutive.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a cohort

> This endpoint allows the creation of a new cohort. The query definition is provided using the Cohort API JSON query definition format.

The cohort will belong to the workspace which owns the provided API key.



## OpenAPI

````yaml POST /v2/cohorts
openapi: 3.0.1
info:
  title: Cohorts API
  version: '1'
  description: Programmatically view and maintain cohort definitions
servers:
  - url: https://api.permutive.app/cohorts-api
security: []
paths:
  /v2/cohorts:
    post:
      tags:
        - v2
      summary: Create cohort
      description: >-
        This endpoint allows the creation of a new cohort. The query definition
        is provided using the Cohort API JSON query definition format.


        The cohort will belong to the workspace which owns the provided API key.
      operationId: postV2Cohorts
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateSegmentV2'
            example:
              name: Example Segment A
              description: This segment is an example for documentation purposes
              query:
                event: Pageview
                frequency:
                  greater_than_or_equal_to: 2
                where:
                  property: properties.client.url
                  condition:
                    contains: football
                during:
                  the_last:
                    value: 30
                    unit: days
              tags:
                - tag_a
                - tag_b
              segment_type: real_time
        required: true
      responses:
        '201':
          description: Cohort in full (including query)
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SegmentQueryApiV2'
              example:
                id: 38470a62-9837-4c86-bbf3-45dd6d52dd83
                code: 12345
                name: Example Segment A
                description: This segment is an example for documentation purposes
                query:
                  event: Pageview
                  frequency:
                    greater_than_or_equal_to: 2
                  where:
                    property: properties.client.url
                    condition:
                      contains: football
                  during:
                    the_last:
                      value: 30
                      unit: days
                tags:
                  - tag_a
                  - tag_b
                state: Enabled
                segment_type: real_time
                created_at: '2022-09-22T15:44:29.518935935Z'
                last_updated_at: '2022-09-22T15:44:29.518937018Z'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HttpErrorResponse'
              example:
                request_id: b887517b-99a2-4ae0-bc32-93d1fb13d1b7
                error:
                  type: https://tools.ietf.org/html/rfc7231#section-6.5.1
                  status_code: 400
                  status: Bad Request
                  code: 1002
                  message: The provided request body was not structured as expected.
                  docs: https://developer.permutive.com/reference#errors
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HttpErrorResponse'
              example:
                request_id: b887517b-99a2-4ae0-bc32-93d1fb13d1b7
                error:
                  type: https://tools.ietf.org/html/rfc7235#section-3.1
                  status_code: 401
                  status: Unauthorized
                  code: 2005
                  message: The supplied authentication is invalid.
                  docs: https://developer.permutive.com/reference#errors
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HttpErrorResponse'
              example:
                request_id: b887517b-99a2-4ae0-bc32-93d1fb13d1b7
                error:
                  type: https://tools.ietf.org/html/rfc7231#section-6.5.3
                  status_code: 403
                  status: Forbidden
                  code: 2001
                  message: >-
                    The API key provided does not provide access to the request
                    operation or resource.
                  docs: https://developer.permutive.com/reference#errors
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HttpErrorResponse'
              example:
                request_id: b887517b-99a2-4ae0-bc32-93d1fb13d1b7
                error:
                  type: https://tools.ietf.org/html/rfc7231#section-6.5.4
                  status_code: 404
                  status: Not Found
                  code: 3000
                  message: The requested resource does not exist.
                  docs: https://developer.permutive.com/reference#errors
        '409':
          description: Conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HttpErrorResponse'
              example:
                request_id: b887517b-99a2-4ae0-bc32-93d1fb13d1b7
                error:
                  type: https://tools.ietf.org/html/rfc7231#section-6.5.8
                  status_code: 409
                  status: Conflict
                  code: 4000
                  message: A resource with this identifier already exists.
                  docs: https://developer.permutive.com/reference#errors
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HttpErrorResponse'
              example:
                request_id: b887517b-99a2-4ae0-bc32-93d1fb13d1b7
                error:
                  type: https://tools.ietf.org/html/rfc7231#section-6.6.1
                  status_code: 500
                  status: Internal Server Error
                  code: 5000
                  message: >-
                    An error of unspecified nature was encountered while
                    processing your request. Feel free to get in touch with us
                    at support@permutive.com referencing the Request ID.
                  docs: https://developer.permutive.com/reference#errors
      security:
        - apiKeyAuth: []
components:
  schemas:
    CreateSegmentV2:
      required:
        - name
        - query
      type: object
      properties:
        name:
          type: string
        description:
          type: string
        query:
          $ref: '#/components/schemas/Json'
        tags:
          type: array
          items:
            type: string
        segmentType:
          $ref: '#/components/schemas/SegmentType'
    SegmentQueryApiV2:
      required:
        - id
        - code
        - name
        - query
        - state
        - segmentType
        - createdAt
        - lastUpdatedAt
      type: object
      properties:
        id:
          type: string
        code:
          type: integer
        name:
          type: string
        description:
          type: string
        query:
          $ref: '#/components/schemas/Json'
        tags:
          type: array
          items:
            type: string
        state:
          type: string
          enum:
            - Enabled
            - Disabled
        workspaceId:
          type: string
        segmentType:
          $ref: '#/components/schemas/SegmentType'
        createdAt:
          type: string
          format: date-time
        lastUpdatedAt:
          type: string
          format: date-time
    HttpErrorResponse:
      required:
        - requestId
        - error
      type: object
      properties:
        requestId:
          type: string
        error:
          $ref: '#/components/schemas/HttpError'
    Json: {}
    SegmentType:
      oneOf:
        - $ref: '#/components/schemas/Offline'
        - $ref: '#/components/schemas/RealTime'
    HttpError:
      required:
        - status
        - code
        - message
      type: object
      properties:
        status:
          $ref: '#/components/schemas/HttpStatus'
        code:
          type: integer
        message:
          type: string
        cause:
          type: string
    Offline:
      type: object
    RealTime:
      type: object
    HttpStatus:
      required:
        - code
      type: object
      properties:
        code:
          type: integer
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      name: k
      in: query

````